coronavirus/urls.py
from django.contrib import admin
from django.urls import path, include

urlpatterns = [
    path('admin/', admin.site.urls),
    path('', include('main.urls', namespace = 'main')),
    path('oauth/', include('oauth2_provider.urls', namespace = 'oauth2_provider')),
]

main/urls.py
from django.urls import path
from django.conf.urls import url
from .import views

app_name = 'main'
urlpatterns = [
    # get all countries Api <----->
    path('api/get/countries/', views.get_all_country, name = 'getallcountries_api'),
    # get file Api <----->
    path('api/get/data/', views.get_data, name = 'getdata_api'),
    # word total case Api <----->
    path('api/word-ranking/total-case/', views.work_total_case_ranking, name = 'wordtotalcase_api'),
    # word total death Api <----->
    path('api/word-ranking/total-death/', views.work_total_death_ranking, name = 'wordtotaldeath_api'),
    # country statistics Api <----->
    path('api/total-statistics/country', views.country_statistics, name = 'countrystatistics_api'),
    # country statistics by date Api <----->
    path('api/total-statistics-bydate/country', views.country_statistics_bydate, name = 'countrystatisticsbydate_api'),

    # index page <----->
    path('', views.index, name = 'indexpage'),
    # soal_1 page <----->
    path('api/soal-one', views.soal_one, name = 'soal1'),
    # soal_2 page <----->
    path('api/soal-two', views.soal_two, name = 'soal2'),
    # soal_3 page <----->
    path('api/soal-three', views.soal_three, name = 'soal3'),
    # soal_4 page <----->
    path('api/soal-four', views.soal_four, name = 'soal4'),
]

main/models.py
from django.db import models
from django.contrib.postgres.fields import JSONField


# ----------------------------------------------------------------------------------------------------------------------------

# country (کشور) Model
class Country(models.Model): 
    name = models.CharField(verbose_name = 'نام کشور', max_length = 255, db_index = True, unique = True)
    code = models.CharField(verbose_name = 'کد کشور', max_length = 2, db_index = True, unique = True)
    population = models.BigIntegerField(verbose_name = 'جمعیت', null = True)
    death_rate = models.FloatField(verbose_name = 'نرخ مرگ', null = True)
    recovery_rate = models.FloatField(verbose_name = 'میزان برآوردن', null = True)
    updated_at = models.DateTimeField(verbose_name = 'به روز شده در', null = True)

    def __str__(self):
        return "{} - {}".format(self.name, self.code)

    class Meta:
        ordering = ('id',)   
        verbose_name = "کشور"
        verbose_name_plural = "کشور ها"

# statistics (آمار) Model
class Statistics(models.Model): 
    FK_Country = models.ForeignKey(Country, on_delete = models.SET_NULL, verbose_name = 'کشور', related_name = 'country_statistics', null = True)
    deaths = models.BigIntegerField(verbose_name = 'کل فوت شده ها')
    confirmed = models.BigIntegerField(verbose_name = 'کل موارد تایید شده')
    recovered = models.BigIntegerField(verbose_name = 'کل موارد بهبود یافته')
    critical =  models.BigIntegerField(verbose_name = 'کل موارد بحرانی')
    timeline = JSONField(verbose_name = 'کشور', null = True, blank = True)
    updated_at = models.DateTimeField(verbose_name = 'به روز شده در')

    def __str__(self):
        return "{} : {}".format(self.FK_Country, self.updated_at)

    def save_country(self, this_timeline):
        data = {}
        data['timeline'] = []
        data['timeline'].append(this_timeline)

        self.timeline = data
        self.save()

    class Meta:
        ordering = ('id',)   
        verbose_name = "آمار"
        verbose_name_plural = "آمار ها"

main/views.py
from rest_framework.decorators import api_view, permission_classes
from rest_framework.permissions import AllowAny, IsAuthenticated
from django.views.decorators.csrf import csrf_exempt
from rest_framework.response import Response
from django.http import JsonResponse
from django.shortcuts import render
from django.utils import timezone
import threading, requests, json
from rest_framework.status import (
    HTTP_400_BAD_REQUEST,
    HTTP_404_NOT_FOUND,
    HTTP_200_OK,
    HTTP_201_CREATED,
    HTTP_202_ACCEPTED,
    HTTP_500_INTERNAL_SERVER_ERROR,
)
from .serializers import *
# get model
from main.models import Statistics, Country

# ----------------------------------------------------------------------------------------------------------------------------

# get all country //req : form request//result: ({message : 'msg' }) OR error
@csrf_exempt
@api_view(["GET"])
@permission_classes([AllowAny])
def get_all_country(request):
    try:
        # get data
        url = "https://corona-api.com/countries"
        r = requests.get(url, allow_redirects = True)
        open('all_country.json', 'wb').write(r.content)
        # read data from json
        result = None
        with open('all_country.json', encoding = 'utf8') as data:
            result = json.load(data)
        # add to database
        for item in result['data']:
            if not Country.objects.filter(name = item['name']).exists():
                Country.objects.create(name = item['name'], code = item['code'], population = item['population'], death_rate = item['latest_data']['calculated']['death_rate'], recovery_rate = item['latest_data']['calculated']['recovery_rate'], updated_at = item['updated_at'])
            else:
                # get this country
                this_country = Country.objects.get(name = item['name'])
                this_country.death_rate = item['latest_data']['calculated']['death_rate']
                this_country.recovery_rate = item['latest_data']['calculated']['recovery_rate']
                this_country.updated_at = item['updated_at']
                this_country.save()
        return JsonResponse({'message' : 'ok'} , status = HTTP_200_OK)
    except Exception as e:
        return JsonResponse({'message' : str(e)}, status = HTTP_500_INTERNAL_SERVER_ERROR)


# get data //req : form request//result: ({message : 'msg' }) OR error
@csrf_exempt
@api_view(["GET"])
@permission_classes([AllowAny])
def get_data(request):
    try:
        for item in Country.objects.all():
            # get data
            url = "http://corona-api.com/countries/" + item.code
            r = requests.get(url, allow_redirects = True)
            if r.status_code == 200:
                open("data/" + item.name + '.json', 'wb').write(r.content)
                # read data from json
                result = None
                with open("data/" + item.name + '.json', encoding = 'utf8') as data:
                    result = json.load(data)
                # add to database
                if not Statistics.objects.filter(FK_Country = item, updated_at = result['data']['updated_at']).exists():
                    Statistics.objects.create(FK_Country = item, deaths = result['data']['latest_data']['deaths'], confirmed = result['data']['latest_data']['confirmed'], recovered = result['data']['latest_data']['recovered'], critical = result['data']['latest_data']['critical'], timeline = result['data']['timeline'], updated_at = result['data']['updated_at'])
                else:
                    # get this statistics
                    this_statistics = Statistics.objects.get(FK_Country = item)
                    this_statistics.deaths = result['data']['latest_data']['deaths']
                    this_statistics.confirmed = result['data']['latest_data']['confirmed']
                    this_statistics.recovered = result['data']['latest_data']['recovered']
                    this_statistics.critical = result['data']['latest_data']['critical']
                    this_statistics.timeline = result['data']['timeline']
                    this_statistics.updated_at = result['data']['updated_at']
                    this_statistics.save()

                print(item.name)
        return JsonResponse({'message' : 'ok'} , status = HTTP_200_OK)
    except Exception as e:
        return JsonResponse({'message' : str(e)}, status = HTTP_500_INTERNAL_SERVER_ERROR)


# work total case ranking //req : form request//result: ({message : 'msg' }) OR error
@csrf_exempt
@api_view(["GET"])
@permission_classes([AllowAny])
def work_total_case_ranking(request):
    try:
        class Data:
            def __init__(self, item, value):
                self.Country = item
                self.Case = value
            def toJSON(self):
                return json.dumps(self, default = lambda o: o.__dict__)
        # set date to list
        result = []
        for item in Country.objects.all():
            if Statistics.objects.filter(FK_Country = item).exists():
                this_object = Statistics.objects.filter(FK_Country = item).latest('updated_at')
                result.append(Data(item.name, (this_object.confirmed)))
        # get value
        def get_value(item):
            return int(item.Case)
        # sort list
        result.sort(reverse = True, key = get_value)
        # set final list
        final_list = []
        for item in result:
            final_list.append(json.loads(item.toJSON()))
        return JsonResponse(final_list, status = HTTP_200_OK, safe = False)
    except Exception as e:
        return JsonResponse({'message' : str(e)}, status = HTTP_500_INTERNAL_SERVER_ERROR)


# work total death ranking //req : form request//result: ({message : 'msg' }) OR error
@csrf_exempt
@api_view(["GET"])
@permission_classes([AllowAny])
def work_total_death_ranking(request):
    try:
        class Data:
            def __init__(self, item, value):
                self.Country = item
                self.Death = value
            def toJSON(self):
                return json.dumps(self, default = lambda o: o.__dict__)
        # set date to list
        result = []
        for item in Country.objects.all():
            if Statistics.objects.filter(FK_Country = item).exists():
                this_object = Statistics.objects.filter(FK_Country = item).latest('updated_at')
                result.append(Data(item.name, this_object.deaths))
        # get value
        def get_value(item):
            return int(item.Death)
        # sort list
        result.sort(reverse = True, key = get_value)
        # set final list
        final_list = []
        for item in result:
            final_list.append(json.loads(item.toJSON()))
        return JsonResponse(final_list, status = HTTP_200_OK, safe = False)
    except Exception as e:
        return JsonResponse({'message' : str(e)}, status = HTTP_500_INTERNAL_SERVER_ERROR)


# country statistics //req : form request//result: ({message : 'msg' }) OR error
@csrf_exempt
@api_view(["POST"])
@permission_classes([AllowAny])
def country_statistics(request):
    try:
        # get data
        country_id = request.POST.get('country')
        # get country
        this_country = Country.objects.get(id = country_id)
        # get statistics
        this_statistics = Statistics.objects.filter(FK_Country = this_country).latest('updated_at')
        return JsonResponse({'Total-Cases' : this_statistics.confirmed, 'Total-Deaths' : this_statistics.deaths, 'Total-Recoverss' : this_statistics.recovered}, status = HTTP_200_OK, safe = False)
    except Exception as e:
        return JsonResponse({'message' : str(e)}, status = HTTP_500_INTERNAL_SERVER_ERROR)


# country statistics by date //req : form request//result: ({message : 'msg' }) OR error
@csrf_exempt
@api_view(["POST"])
@permission_classes([AllowAny])
def country_statistics_bydate(request):
    try:
        # get data
        country_id = request.POST.get('country')
        this_date = request.POST.get('date')
        # get country
        this_country = Country.objects.get(id = country_id)
        # get statistics
        this_statistics = Statistics.objects.get(FK_Country = this_country)
        # search data
        for item in this_statistics.timeline:
            if item['date'] == this_date:
                return JsonResponse({'Total-Cases' : this_statistics.confirmed, 'Total-Deaths' : this_statistics.deaths, 'Total-Recoverss' : this_statistics.recovered}, status = HTTP_200_OK, safe = False)
            else:
                return JsonResponse({'Total-Cases' : None, 'Total-Deaths' : None, 'Total-Recoverss' : None}, status = HTTP_200_OK, safe = False)
    except Exception as e:
        return JsonResponse({'message' : str(e)}, status = HTTP_500_INTERNAL_SERVER_ERROR)


# index page
def index(request):
    # get country
    countries = Country.objects.all().order_by('name')

    context = {
        'Country':countries, 
    }
    return render(request, 'main.html', context)

# soal_one page
def soal_one(request):
    # get data
    url = "http://localhost:8000/api/word-ranking/total-case/"
    r = requests.get(url, allow_redirects = True)
    if r.status_code == 200:
        open('soal-one.json', 'wb').write(r.content)
        # read data from json
        result = None
        with open('soal-one.json', encoding = 'utf8') as data:
            result = json.load(data)

    context = {
        'Result':result
    }
    return render(request, 'soal_1.html', context)


# soal_two page
def soal_two(request):
    # get data
    url = "http://localhost:8000/api/word-ranking/total-death/"
    r = requests.get(url, allow_redirects = True)
    if r.status_code == 200:
        open('soal-two.json', 'wb').write(r.content)
        # read data from json
        result = None
        with open('soal-two.json', encoding = 'utf8') as data:
            result = json.load(data)

    context = {
        'Result':result
    }
    return render(request, 'soal_2.html', context)


# soal_three page

templates/main.html
<!DOCTYPE html>
    <html>
        <title>index</title>
        <h1>Index page</h1>
        <body>
            <br>
            <a href="{% url "main:soal1" %}" target="_blank"><p>Soal-1</p></a>
            <p>--------------------</p>
            <a href="{% url "main:soal2" %}" target="_blank"><p>Soal-2</p></a>
            <p>--------------------</p>
            <form method="POST" action="{% url "main:soal3" %}">
                {% csrf_token %}
                <div>
                    <label for="inputcountry"></label>
                    <select id="inputcountry" name="country_one">
                        {% for item in Country %}
                            <option value="{{item.id}}">{{item.name}}</option>
                        {% endfor %}
                    </select>
                </div>
                <br>
                <button type="submit">Soal-3</button>
            </form>
            <p>--------------------</p>
            <form method="POST" action="{% url "main:soal4" %}">
                {% csrf_token %}
                <div>
                    <label for="inputcountry">Country</label>
                    <select id="inputcountry" name="country">
                        {% for item in Country %}
                            <option value="{{item.id}}">{{item.name}}</option>
                        {% endfor %}
                    </select>
                    <br>
                    <label for="inputdate">Date</label>
                    <input id="inputdate" name="date" type="date">
                </div>
                <br>
                <button type="submit">Soal-4</button>
            </form>
        </body>
</html>

templates/resilt.html
<!DOCTYPE html>
    <html>
        <title>Result</title>
        <h1>Result</h1>
        <body>
            <br>
            <div>
                <table>
                    <thead>
                        <tr>
                            <th>Total Cases</th>
                            <th>Total Deaths</th>
                            <th>Total Recovers</th>
                        </tr>
                    </thead>

                    <tbody>
                        <tr>
                            <td>{{Cases}}</td>
                            <td>{{Deaths}}</td>
                            <td>{{Recovers}}</td>
                        </tr>
                    </tbody>
                </table>
            </div>
        </body>
</html>

templates/soal_1.html
<!DOCTYPE html>
    <html>
        <title>Soal - One</title>
        <h1>Soal 1</h1>
        <body>
            <br>
            <div>
                <table>
                    <thead>
                        <tr>
                            <th>Country</th>
                            <th>Total Cases</th>
                        </tr>
                    </thead>

                    <tbody>
                        {% for item in Result %}
                            <tr>
                                <td>{{item.Country}}</td>
                                <td>{{item.Case}}</td>
                            </tr>
                        {% endfor %}
                    </tbody>
                </table>
            </div>
        </body>
</html>

templates/soal_2.html
<!DOCTYPE html>
    <html>
        <title>Soal - Two</title>
        <h1>Soal 2</h1>
        <body>
            <br>
            <div>
                <table>
                    <thead>
                        <tr>
                            <th>Country</th>
                            <th>Total Deaths</th>
                        </tr>
                    </thead>

                    <tbody>
                        {% for item in Result %}
                            <tr>
                                <td>{{item.Country}}</td>
                                <td>{{item.Death}}</td>
                            </tr>
                        {% endfor %}
                    </tbody>
                </table>
            </div>
        </body>
</html>